##########################################################
# library type functions for use with casino by DaRKHeaRT
##########################################################
# charreplace <string> <key> <with>       - by dopestar
# checkpass <username> <password>         - by darkheart
# fixlenc <txt> <length <char>            - by vr_dude
# fixsize <size>                          - by vr_dude/darkheart
# filt <data>                             - by thanatos?
# ldelete <list> <value>                  - by dopestar
# round <number> <decimal place>          - by vr_dude
# splitlines <info> <length to split at>  - by dopestar
##########################################################
# casino:announce <msg>
# casino:connftp
# casino:checkscripts
# casino:loaddb
# casino:savedb
# casino:match <idx>
# casino:matchuser <username>
# casino:matchidx <nick> <uhost> <username>
# casino:readuserfile <what> <username>
# casino:changecredit <username> <amount>
# casino:creditcheck <username> <amount> <inmb>
# casino:stats <idx> <username>
# casino:testbetsize <size>
# casino:killoldtimers
# casino:set_idle
# casino:reset_idle <username>
# casino:clearoldinfo <username>
# casino:statline <username>
# casino:dealer <dealername> <action>
# casino:quit <nick> <username>
# casino:runningtotal <username> <amount>
### roulette procs
# casino:roulette:c <numero>
# casino:roulette:isnumber? <numero>
# casino:roulette:cu <username> <number>
# casino:roulette:beton <username> <numero>
### blackjack procs
# casino:blackjack:dealerplay <username> <idx>
# casino:blackjack:checktotal <username>
# casino:blackjack:randomcard <username>
##########################################################

proc u {} {return "\037"}
proc r {} {return "\026"}
proc b {} {return "\002"}

proc charreplace { string key with } {
  if ![string match *$key* $string] { return $string }
  set out ""
  for {set j 0} {$j < [string length $string]} {incr j} {
    set a [string index $string $j]
    if { $a == $key } { set a $with }
      append out $a
    }
  return $out
}

proc checkpass {username pass} { global glbindir
  catch {[exec "$glbindir/passchk" $username $pass]} result
  if {[string match "*NO MATCH!*" $result]} {return 0}
  if {[string match "*MATCH!*" $result]} {return 1}
  return 0
}

proc fixlenc {txt len char} {
  while {[string length $txt] < $len} { append txt $char }
  return $txt
}

proc fixsize {size} {
  if {$size == ""} { return [b][b] }
  if {$size > 0} {
    if {$size >= 1048576} {
      return "[round [expr $size / 1048576.0] 2]GB"
    } elseif {$size >= 1024} {
      return "[round [expr $size / 1024.0] 2]MB"
    } else {
      return "$size K"
    }
  } {
    if {$size <= -1048576} {
      return "[round [expr $size / 1048576.0] 2]GB"
    } elseif {$size <= -1024} {
      return "[round [expr $size / 1024.0] 2]MB"
    } else {
      return "$size K"
    }
  }
}

proc ldelete { list value } {
  set a [lsearch -exact $list $value]
  if { $a >= 0 } {
    return [lreplace $list $a $a]
  } else {
    return $list }
}

proc putchan { chan msg } { putserv "PRIVMSG $chan : $msg" };             # shortcut - channel msg
proc putnot { nick msg } { putserv "NOTICE $nick : $msg" };               # shortcut - notice nick
proc putmsg { nick msg } { putserv "PRIVMSG $nick : $msg" };              # shortcut - msg nick

proc round {num dec} {
  if {[string first . $num] != -1} {
    set num [string range $num 0 [expr [string first . $num] + $dec]]
    set num [fixlenc $num [expr [string first . $num] + $dec + 1] 0]
    return $num
  } else {
    append num "." ;
    set num [fixlenc $num [expr [string first . $num] + $dec + 1] 0]
    return $num
  }
}

proc filt {data} {
 regsub -all -- \\\\ $data \\\\\\\\ data; regsub -all -- \\\[ $data \\\\\[ data; regsub -all -- \\\] $data \\\\\] data
 regsub -all -- \\\} $data \\\\\} data; regsub -all -- \\\{ $data \\\\\{ data; regsub -all -- \\\" $data \\\\\" data; return $data
}

proc splitlines { info length } {
        set times [expr [llength $info] / $length ]
        set extra [lrange $info [expr [llength $info] - [expr [llength $info] - [expr $times * $length ]]] end]
        set output ""; set l 0
        for {set i 0} {$i<$times} {incr i} {
                set output1 ""
                set limit [expr $length + $l ]
                for {} {$l<$limit} {incr l} { append output1 "[lindex $info $l] " }
                lappend output [string trimright $output1 " "]
        }
        if { $extra != "" } { lappend output $extra }
        return $output
}

proc casino:announce {i msg} {global casinoauth
  foreach id [array names casinoauth] {
    if {$id != $i} {
      catch {putdcc $id "$msg"} errormsg
    }
  }
}

proc casino:checkscripts {} { global glbindir
  if {![file exists $glbindir/passchk]} {
    putlog "casino: passchk does not exist in your glftpd bin dir."
    uplevel #0 { die }
  }
}

proc casino:cleandb {} { global x casinosection casino usr
  foreach u [array names usr] {
    if {[lsearch -exact [array names casinosection] $x($u,defaultsection)] == -1} {set x($u,defaultsection) $casino(defaultsection) }
    if {[lsearch -exact $casino(dealers) $x($u,dealer)] == -1 } {set x($u,dealer) $casino(defaultdealer) }
    if {![info exists x($u,all_won)]} { set x($u,all_won) 0 }
    if {![info exists x($u,all_lost)]} { set x($u,all_lost) 0 }
    if {![info exists x($u,echo)]} {
      set x($u,echo) off
    } {
      if {$x($u,echo) == "-"} {
        set x($u,echo) off
      }
    }
  }
}

proc casino:loaddb {} {
  if [file exist scripts/casino.dat] {
    uplevel {
      source scripts/casino.dat
    }
  }
}

proc casino:savedb {} { global fields x usr
  set file [open scripts/casino.dat w]
  foreach u [lsort [array names usr]] {
    puts $file "set usr\($u\) \"[filt $usr($u)]\""
    foreach field $fields {
      if {![info exists x($u,$field)]} { set x($u,$field) "-" }
      puts $file "set x($u,$field) \"[filt $x($u,$field)]\""
    }
    puts $file ""
  }
  close $file
}

proc casino:match { idx } { global casinoauth
  foreach id [array names casinoauth] {
    if {$id == $idx} {return [lindex $casinoauth($id) 2]}
  }
  return 0
}

# 5= user matchs, nick matchs uhost is different.       (your logged in using different hostname already)
# 4= hostname matchs and username match nick doesnt     (your logged in using a differnt nickname)
# 3= username valid, nick|uhost are not                 (someone else using account)
# 2= nick|uhost are already on another user             (logged in under different name)
# 1= direct match                                       (already logged in)
# 0= no match                                           (not logged in)

proc casino:matchuser {username} { global casinoauth
  foreach id [array names casinoauth] {
    set iusername [lindex $casinoauth($id) 2]
    if {$username == $iusername} {
      return $id
    }
  }
  return "nomatch"
}

proc casino:matchidx { nick uhost username } { global casinoauth
  foreach id [array names casinoauth] {
    set inick [lindex $casinoauth($id) 0] ; set iuhost [lindex $casinoauth($id) 1] ; set iusername [lindex $casinoauth($id) 2]
    if {$casinoauth($id) == "$nick $uhost $username"} {
      return "1"
    } elseif {($username == $iusername) && ($nick != $inick) && ($uhost == $iuhost)} {
      return "4"
    } elseif {($username == $iusername) && ($nick == $inick) && ($uhost != $iuhost)} {
      return "5"
    } elseif {($username == $iusername) && ($nick != $inick) && ($uhost != $iuhost)} {
      return "3"
    } elseif {($username != $iusername) && ($nick == $inick) || ($uhost == $iuhost)} {
      return "2"
    }
  }
  return 0
}

proc casino:readuserfile { what username } { global glusers
        set userfile [open $glusers/$username r]
        while {![eof $userfile]} {
          set line [gets $userfile]
          if {[lindex $line 0] == "$what"} {
            close $userfile ; return [lrange $line 1 end]
          }
        }
        close $userfile
}

proc casino:changecredit { username total } { global glusers casino x
       if {[file exists $glusers/$username.lock]} { return "casino!error]: lock file exists for username (glftpd using the userfile) no changes to credits made." }
       set lockfile [open $glusers/$username.lock w] ; puts $lockfile "[pid]" ; close $lockfile

       set output ""
       set sectionpos "[expr [lsearch -exact $casino(order) $x($username,defaultsection)] + 1]"
       set amount "[lindex [split [round [expr $total * 1024] 0] "."] 0]"
       if {$total < 0} { set amount [string trim $amount "-"] }
       if {$total == 0} {return}
       if {[file readable $glusers/$username]} { set userfile [open $glusers/$username r] } else { return "casino!error]: $glusers/$username could not be read (bad file permissions)" }
       while {![eof $userfile]} {
         set line [gets $userfile]
         if {[lindex $line 0] == "CREDITS"} {
           if {$total < 0} {
             lappend output [lreplace $line $sectionpos $sectionpos [expr [lindex $line $sectionpos] - $amount]]
             set x($username,all_lost) [expr $x($username,all_lost) + ($amount / 1024)]
             set x($username,lost) [expr $x($username,lost) + ($amount / 1024)]
             set result "Successfully took [fixsize $amount] from $username"
           } {
             lappend output [lreplace $line $sectionpos $sectionpos [expr [lindex $line $sectionpos] + $amount]]
             set x($username,all_won) [expr $x($username,all_won) + ($amount / 1024)]
             set x($username,won) [expr $x($username,won) + ($amount / 1024)]
             set result "Successfully transferred [fixsize $amount] to $username."
           }
         } elseif {$line == ""} {
           #donothing
         } else {
           lappend output $line
         }
       }
       close $userfile
       if {[file writable $glusers/$username]} {set newuserfile [open $glusers/$username w]} else {return "casino!error]: $glusers/$username could not be changed (bad file permissions)"}
       foreach line $output { puts $newuserfile "$line" } ; close $newuserfile
       file delete $glusers/$username.lock
       catch {[file attributes $glusers/$username -permissions 0666]} res
       casino:savedb
       return "$result"
}

proc casino:creditcheck {username amount} { global casino x
        set creds [casino:readuserfile CREDITS $username]
        set available [expr [lindex $creds [lsearch $casino(order) $x($username,defaultsection)]] / 1024]
        if {[info exists casino($username,runningtotal)]} {
          set available [expr $available - $casino($username,runningtotal)]
        }
        if {$available < $amount} {
          return 0
        } {
          return 1
        }
}

proc casino:stats { idx username } { global casinosection x casino
        putdcc $idx ".. \[$casino(ver)\] .................. .... "
        putdcc $idx ".            user : $username"
        set counter 0 ; set creds [casino:readuserfile CREDITS $username]
        foreach sn $casino(order) {
          putdcc $idx ". [format %15s "credits($sn)"] : [fixsize [lindex $creds $counter]]" ; incr counter
        }
        putdcc $idx ". times logged in : $x($username,loggedin)"
        putdcc $idx ". default section : $x($username,defaultsection)"
        putdcc $idx ".     dealer name : $x($username,dealer)"
        putdcc $idx ".     alltime won : [fixsize [expr $x($username,all_won) * 1024]]"
        putdcc $idx ".    alltime lost : [fixsize [expr $x($username,all_lost) * 1024]]"
        putdcc $idx ".................. . . . . ..."
}

proc casino:testbetsize { amount } { global casino
  if {($amount <= $casino(maxbet) && $amount >= $casino(minbet)) || ($amount == 0)} {
    return 1
  } {
    return 0
  }
}

proc casino:killoldtimers {} {
  foreach this [timers] {
    if {[string compare [lindex $this 1] "casino:set_idle"] == 0} {
      killtimer [lindex $this 2]
    }
  }
}

proc casino:set_idle {} { global casinoauth x casino
   foreach id [array names casinoauth] {
     set u [lindex $casinoauth($id) 2]
     set x($u,idle) [expr $x($u,idle) - 1]
     set x($u,online) [expr $x($u,online) + 1]
     if {$x($u,idle) == 2} { putdcc $id "casino!idle]: warning $u... 2minutes until timeout." }
     if {$x($u,idle) == 0} {
       foreach line [casino:quit $u] { putdcc $id $line }
       putdcc $id "casino!idle]: idle for $casino(timer) minutes.. $u logged off"
       casino:announce $id "casino!logout]: $u idle for $casino(timer) minutes. logged off the casino!"
       unset casinoauth($id)
       casino:savedb
     }
   }
   timer 1 casino:set_idle
}

proc casino:reset_idle {username} {global casino x
  set x($username,idle) $casino(timer)
}

proc casino:clearoldinfo {username} {global roulette casino bj
  if [info exists bj($username,deck)] { unset bj($username,deck) }
  if [info exists bj($username,ingame)] { unset bj($username,ingame) }
  if [info exists roulette($username,beton)] {unset roulette($username,beton)}
  if [info exists roulette($username,betcounter)] {set roulette($username,betcounter) 0}
  if [info exists casino($username,runningtotal)] {unset casino($username,runningtotal)}
}

proc casino:statline {username} {global casino x ; set output "-"
        set counter 0 ; set creds [casino:readuserfile CREDITS $username]
        foreach sn $casino(order) {
          set output "$output[format %10s ": credits($sn)"] [fixsize [lindex $creds $counter]] "
          incr counter
        }
        set output "$output: won $x($username,won)MB : lost $x($username,lost)MB :-"
        return $output
}

proc casino:dealer { dealer action } {
  switch -exact -- $dealer {
    "wally" {
        switch -exact -- $action {
              "quitwinner" {
               set numero [rand 5]
               if {$numero == 0} { return "dealer: \"and dont come back!\""}
               if {$numero == 1} { return "dealer: \"oh you'll come back... and when you do... muahahaha\""}
               if {$numero == 2} { return "dealer: \"i suppose i have to let some people win.\""}
               if {$numero == 3} { return "dealer: \"in the long run your all losers :P\""}
               if {$numero == 4} { return "dealer: \"cya next time!\""}
              }
              "quitloser" {
               set numero [rand 5]
               if {$numero == 0} { return "dealer: \"you sure you dont want to come back and play some more? <g>\""}
               if {$numero == 1} { return "dealer: \"better luck next time... not. :P \""}
               if {$numero == 2} { return "dealer: \"wally's final thoughts: are you sure this game isnt rigged?\""}
               if {$numero == 3} { return "dealer: \"prehaps you should read up more on the game and then come back.\""}
               if {$numero == 4} { return "dealer: \"cya next time!\""}
              }
              "dealing" {
               set numero [rand 5]
               if {$numero == 0} { return "dealer: \"do you feel lucky.. punk?\""}
               if {$numero == 1} { return "dealer: \"do you think this game is geared up for me to win or for you to win?\""}
               if {$numero == 2} { return "dealer: \"oh uh you shouldn't of pressed that button.\""}
               if {$numero == 3} { return "dealer: \"oh spin that wheel!\""}
               if {$numero == 4} { return "dealer: \"look no hands\""}
              }
              "winner" {
               set numero [rand 5]
               if {$numero == 0} { return "dealer: \"damn man your on fire!\""}
               if {$numero == 1} { return "dealer: \"why dont you *cough* spin again :>\""}
               if {$numero == 2} { return "dealer: \"but i have no more credits to give?\""}
               if {$numero == 3} { return "dealer: \"yeah you won this time...\""}
               if {$numero == 4} { return "dealer: \"sorry i slipped we'll have to spin that one again.\""}
              }
              "nochange" {
               set numero [rand 5]
               if {$numero == 0} { return "dealer: \"hey you didn't lose anything.. maybe if you spin again you might win?\""}
               if {$numero == 1} { return "dealer: \"now that was rather pointless wasnt it.\""}
               if {$numero == 2} { return "dealer: \"you realise im a homophobic dealer.. get away from me.\""}
               if {$numero == 3} { return "dealer: \"muaahmaumauahamaiahaaahhahaaaahaaahahaaaa <evil laugh>\""}
               if {$numero == 4} { return "dealer: \"kuku?\""}
              }
              "loser" {
               set numero [rand 8]
               if {$numero == 0} { return "dealer: \"gimme those credits biatch!\""}
               if {$numero == 1} { return "dealer: \"oh did you lose again?\""}
               if {$numero == 2} { return "dealer: \"didn't you say you know how to play this game?\""}
               if {$numero == 3} { return "dealer: \"i should be in for a pay rise soon <g>\""}
               if {$numero == 4} { return "dealer: \"oh come now, just one more spin :>\""}
               if {$numero == 5} { return "dealer: \"looks like you might actually have to trade again\""}
               if {$numero == 6} { return "dealer: \"looks like your back to working that tired old street cornor :>\""}
               if {$numero == 7} { return "dealer: \"SHOW ME THE MONEY!\""}
              }
              "nobet" {
               set numero [rand 5]
               if {$numero == 0} { return "dealer: \"you think im going to spin this wheel when you havnt even placed a bet? pfft.\""}
               if {$numero == 1} { return "dealer: \"well i would spin it but i cant be bothered.\""}
               if {$numero == 2} { return "dealer: \"no. i dont think i will.\""}
               if {$numero == 3} { return "dealer: \"they aint payin me to spin a wheel with a table devoid of bets.\""}
               if {$numero == 4} { return "dealer: \"could you spin it? im a bit tired.\""}
              }
              "cleartable" {
               set numero [rand 1]
               if {$numero == 0} { return "dealer: \"clearing the table of bets!\""}
              }
              "bj_nobet" {
               set numero [rand 1]
               if {$numero == 0} { return "dealer: \"you havnt placed a bet!\""}
              }
         }
     }
     "hank" {
        switch -exact -- $action {
              "quitwinner" {
               set numero [rand 5]
               if {$numero == 0} { return "dealer: \"don't worry. you won't win again. enjoy it this time!\""}
               if {$numero == 1} { return "dealer: \"*laff* lucky sob!\""}
               if {$numero == 2} { return "dealer: \"we all win sometime i guess. :/\""}
               if {$numero == 3} { return "dealer: \"get away from my table punkass!\""}
               if {$numero == 4} { return "dealer: \"come back soon!\""}
              }
              "quitloser" {
               set numero [rand 5]
               if {$numero == 0} { return "dealer: \"you sure you dont want to come back and play some more? <g>\""}
               if {$numero == 1} { return "dealer: \"please remove my foot from your ass! ;)\""}
               if {$numero == 2} { return "dealer: \"wow. how does anyone lose that bad and still have the balls to keep trying?\""}
               if {$numero == 3} { return "dealer: \"you suck man. learn how to play. simple.\""}
               if {$numero == 4} { return "dealer: \"peace out. ;)\""}
              }
              "dealing" {
               set numero [rand 5]
               if {$numero == 0} { return "dealer: \"drum roll please!\""}
               if {$numero == 1} { return "dealer: \"im gonna take all your credits fool! hahahaha\""}
               if {$numero == 2} { return "dealer: \"you're going down!.\""}
               if {$numero == 3} { return "dealer: \"spin that wheel! oh yea!\""}
               if {$numero == 4} { return "dealer: \"weeeeeeee!\""}
              }
              "winner" {
               set numero [rand 5]
               if {$numero == 0} { return "dealer: \"stop winning!!\""}
               if {$numero == 1} { return "dealer: \"wait! lemme rig the wheel this time around first!\""}
               if {$numero == 2} { return "dealer: \"no biggie. i got more credits then you'll ever have! ;)\""}
               if {$numero == 3} { return "dealer: \"lucky...\""}
               if {$numero == 4} { return "dealer: \"boooo. do over!\""}
              }
              "nochange" {
               set numero [rand 5]
               if {$numero == 0} { return "dealer: \"hrm. draw. spin again please.\""}
               if {$numero == 1} { return "dealer: \"i hate ties!\""}
               if {$numero == 2} { return "dealer: \"did u do that on purpose?\""}
               if {$numero == 3} { return "dealer: \"ugh. i hate that!\""}
               if {$numero == 4} { return "dealer: \"hey, do you workout? <- (compliment, nowspend more credits betting.)\""}
              }
              "loser" {
               set numero [rand 8]
               if {$numero == 0} { return "dealer: \"OUCH! this has GOT to suck for you. ;)\""}
               if {$numero == 1} { return "dealer: \"damn. you lose alot eh?\""}
               if {$numero == 2} { return "dealer: \"do you know how to play this game?\""}
               if {$numero == 3} { return "dealer: \"winning all your credits is becoming boring buddy. :/\""}
               if {$numero == 4} { return "dealer: \"you know you want to play again.\""}
               if {$numero == 5} { return "dealer: \"god forbit you have to actually get credits the old fashioned way. let this be a lesson!\""}
               if {$numero == 6} { return "dealer: \"you\'d make more money sucking dick at the train station then playing this game man.\""}
               if {$numero == 7} { return "dealer: \"wow. you\'re terrible. :/!\""}
              }
              "nobet" {
               set numero [rand 5]
               if {$numero == 0} { return "dealer: \"try placing a bet first there dummy.\""}
               if {$numero == 1} { return "dealer: \"how many times do i have to tell you to bet first!?\""}
               if {$numero == 2} { return "dealer: \"no. i don't want to.\""}
               if {$numero == 3} { return "dealer: \"where in the hell is your bet?.\""}
               if {$numero == 4} { return "dealer: \"it's your turn to spin. i don't feel like it right now.\""}
              }
              "cleartable" {
               set numero [rand 1]
               if {$numero == 0} { return "dealer: \"clearing the table of bets!\""}
              }
              "bj_nobet" {
               set numero [rand 1]
               if {$numero == 0} { return "dealer: \"you havnt placed a bet!\""}
              }
         }
     }
     "silentbob" {
        if {$action == "nobet"} {
          return "dealer: \"no bets on table.\""
        } elseif {$action == "bjnobet"} {
          return "dealer: \"you havnt placed a bet!\""
        } {
          return ""
        }
     }
  }
}

proc casino:quit {username} { global x ; set output ""
  set x($username,outcome) [expr $x($username,won) - $x($username,lost)]
  lappend output "during this session you won $x($username,won)MB and lost $x($username,lost)MB"
  if {$x($username,outcome) > 0} {
    lappend output "[casino:dealer $x($username,dealer) "quitwinner"]"
  } {
    lappend output "[casino:dealer $x($username,dealer) "quitloser"]"
  }
  return $output
}

proc casino:alltime {idx} {global usr x casino
  set winnerlist ""
  set loserlist ""
  set totalwon 0
  set totallost 0
  set totallogins 0
  set totalusers 0
  foreach u [array names usr] {
    lappend winnerlist "[format %13s $u] |  [format %12s "$x($u,all_won) MB |"]"
    lappend loserlist "[format %13s $u] |  [format %12s "$x($u,all_lost) MB |"]"
    set totallost [expr $totallost + $x($u,all_lost)]
    set totalwon [expr $totalwon + $x($u,all_won)]
    set totallogins [expr $totallogins + $x($u,loggedin)]
    incr totalusers
  }
  set winnerlist [lsort -decreasing -integer -index 2 ${winnerlist}]
  set loserlist [lsort -decreasing -integer -index 2 ${loserlist}]

  putdcc $idx "____________________________________"
  putdcc $idx "|    total logins: [format %-15s $totallogins] |"
  putdcc $idx "|       total won: [format %-15s [fixsize [expr $totalwon * 1024]]] |"
  putdcc $idx "|      total lost: [format %-15s [fixsize [expr $totallost * 1024]]] |"
  putdcc $idx "| amount of users: [format %-15s $totalusers] |"
  putdcc $idx "|__________________________________|"

  set counter 0
  putdcc $idx "____________________________________"
  putdcc $idx "[u]| no |      username |  amount won |[u]"
  foreach line $winnerlist {
    incr counter
    if {$counter <= $casino(aluplines)} {putdcc $idx "| [format %2s $counter] | $line"}
  }
  putdcc $idx "|__________________________________|"
  putdcc $idx ""
  set counter 0
  putdcc $idx "____________________________________"
  putdcc $idx "[u]| no |      username | amount lost |[u]"
  foreach line $loserlist {
    incr counter
    if {$counter <= $casino(aldnlines)} {putdcc $idx "| [format %2s $counter] | $line"}
  }
  putdcc $idx "|__________________________________|"
}


### roulette procs

set roulette(numbers) "1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36"
set roulette(red) "1 3 5 7 9 12 14 16 18 19 21 23 25 27 30 32 34 36"
set roulette(black) "2 4 6 8 10 11 13 15 17 20 22 24 26 28 29 31 33 35"
set roulette(odd) "1 3 5 7 9 11 13 15 17 19 21 23 25 27 29 31 33 35"
set roulette(even) "2 4 6 8 10 12 14 16 18 20 22 24 26 28 30 32 34 36"
set roulette(low) "1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19"
set roulette(high) "20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36"
set roulette(five) "00 0 1 2 3"
set roulette(column) "1.4.7.10.13.16.19.22.25.28.31.34 2.5.8.11.14.17.20.23.26.29.32.35 3.6.9.12.15.16.21.22.27.30.33.36"
set roulette(dozen) "1.2.3.4.5.6.7.8.9.10.11.12 13.14.15.16.17.18.19.20.21.22.23.24 25.26.27.28.29.30.31.32.33.34.35.36"
set roulette(street) "1.2.3 4.5.6 7.8.9 10.11.12 13.14.15 16.17.18 19.20.21 22.23.24 25.26.27 28.29.30 31.32.33 34.35.36"
set roulette(split) {1.2 2.3 4.5 5.6 6.7 7.8 9.10 10.11 11.12 13.14 14.15 16.17 17.18 18.19 19.20 20.21 21.22 22.23 23.24
                     24.25 26.27 27.28 28.29 29.30 30.31 31.32 32.33 33.34 34.35 35.36}


proc casino:roulette:c { numero } { global roulette
  if {[lsearch -exact $roulette(red) $numero] != -1} {
    return "red $numero"
  } {
    if {[lsearch -exact $roulette(black) $numero] != -1} {
      return "black $numero"
    } {
      return $numero
    }
  }
}

proc casino:roulette:isnumber? { numero } { global roulette
  if {([lsearch -exact $roulette(numbers) $numero] != -1) || ($numero == "00") || ($numero == "0")} {
    return 1
  } {
    return 0
  }
}

proc casino:roulette:cu { username numero } { global roulette
  if {[string length $numero] == 1} {
    if {[lsearch -exact $roulette(red) $numero] != -1} {
      if {[lsearch -exact $roulette($username,beton) $numero] != -1} {
        return ".[b][u]$numero[u][b]"
      }
      return ".[b]$numero[b]"
    }
    if {[lsearch -exact $roulette($username,beton) $numero] != -1} {
      return ".[u]$numero[u]"
    }
    return ".$numero"
  } {
    if {[lsearch -exact $roulette(red) $numero] != -1} {
      if {[lsearch -exact $roulette($username,beton) $numero] != -1} {
        return "[b][u]$numero[u][b]"
      }
      return "[b]$numero[b]"
    }
    if {[lsearch -exact $roulette($username,beton) $numero] != -1} {
      return "[u]$numero[u]"
    }
    return $numero
  }
}

proc casino:runningtotal {username amount} {global casino
  if {![info exists casino($username,runningtotal)]} {
    return "$amount"
  } {
    return "[expr $casino($username,runningtotal) + $amount]"
  }
}

proc casino:roulette:beton { username numero } {global roulette
  if {![info exists roulette($username,beton)]} {
    return "$numero"
  } {
    return "$roulette($username,beton) $numero"
  }
}


### blackjack procs

set bj(sitat) "17"
set cards(deck) {d.2 d.3 d.4 d.5 d.6 d.7 d.8 d.9 d.10 d.Jack d.Queen d.King d.Ace
                 h.2 h.3 h.4 h.5 h.6 h.7 h.8 h.9 h.10 h.Jack h.Queen h.King h.Ace
                 s.2 s.3 s.4 s.5 s.6 s.7 s.8 s.9 s.10 s.Jack s.Queen s.King s.Ace
                 c.2 c.3 c.4 c.5 c.6 c.7 c.8 c.9 c.10 c.Jack c.Queen c.King c.Ace}

proc casino:blackjack:winner {idx username ratio} {global bj
  set bj($username,winnings) [expr $bj($username,bet) * $ratio]
  putdcc $idx "[casino:changecredit $username "$bj($username,winnings)"]"
}

proc casino:blackjack:dealerplay {username idx} { global cards bj
  set bj(dealer,cards) ""
  set bj(dealer,deck) "$bj($username,deck)"
  set bj(dealer,status) "0"

  putdcc $idx "Dealer drew a [casino:blackjack:randomcard "dealer"]"
  set bj(dealer,status) [casino:blackjack:checktotal "dealer"]

  while {($bj(dealer,total) < $bj(sitat)) && ($bj(dealer,status) == 0) } {
    putdcc $idx "Dealer drew a [casino:blackjack:randomcard "dealer"]"
    set bj(dealer,status) [casino:blackjack:checktotal "dealer"]
  }

  if {$bj(dealer,status) == 1} { putdcc $idx "Dealer got blackjack.... keeping your bet." ; return}
  if {($bj(dealer,status) != 1) && ($bj($username,status) == 1)} { putdcc $idx "You got Blackjack.... Pays 1:$bj(winnings,blackjack) !" ; casino:blackjack:winner $idx $username $bj(winnings,blackjack) ; return}

  if {($bj(dealer,status) == 2) && ($bj($username,status) != 1)} { putdcc $idx "Dealer got 5 card trick. you lose, keeping your bet." ; return}
  if {($bj(dealer,status) != 2) && ($bj($username,status) == 2)} { putdcc $idx "You got a 5 card trick.... You win." ; casino:blackjack:winner $idx $username $bj(winnings,5cardtrick) ; return}

  if {($bj(dealer,status) == 4) && ($bj($username,status) == 4)} { putdcc $idx "Dealer busted also! lucky you!... refunding your bet." ; casino:blackjack:winner $idx $username $bj(winnings,nowinner) ; return}
  if {($bj(dealer,status) == 4) && ($bj($username,status) != 4)} { putdcc $idx "Dealer busted. You win!" ; casino:blackjack:winner $idx $username $bj(winnings,winner) ; return}
  if {($bj(dealer,status) != 4) && ($bj($username,status) == 4)} { putdcc $idx "Dealer sits on: $bj(dealer,total) , You sat on $bj($username,total)" ; putdcc $idx "You busted!. Dealer won, keeping your bet.!" ; return}

  putdcc $idx "Dealer sits on: $bj(dealer,total) , You sat on $bj($username,total)"

  if {$bj(dealer,total) >= $bj($username,total)} {
    putdcc $idx "Dealer wins, keeping your bet."
    return
  } {
    putdcc $idx "You win"
    casino:blackjack:winner $idx $username $bj(winnings,winner)
    return
  }

}

# 5= split if you want  continue
# 4= busted             stop
# 3= 21 (force sit)     stop
# 2= 5 card trick       stop
# 1= blackjack          stop
# 0= continue           (continue?)

proc casino:blackjack:checktotal {username} { global cards bj
  set bj($username,total) 0
  set bj($username,spliton) 0

  foreach card $bj($username,cards) {
    if {$card == "Ace"} {
      set bj($username,total) [expr $bj($username,total) + 11]
    } elseif {$card == "King" || $card == "Queen"} {
      set bj($username,total) [expr $bj($username,total) + 10]
    } elseif {$card == "Jack"} {
      set bj($username,total) [expr $bj($username,total) + 10]
    } else {
      set bj($username,total) [expr $bj($username,total) + $card]
    }
  }

  set a [lsearch $bj($username,cards) "Ace"]
  while {($a != -1) && ($bj($username,total) > 21)} {
      set bj($username,total) [expr $bj($username,total) - 10]
      set bj($username,cards) [lreplace $bj($username,cards) $a $a "1"]
      set a [lsearch $bj($username,cards) "Ace"]
  }

  if {([lsearch $bj($username,cards) "Ace"] != -1) && ([lsearch $bj($username,cards) "Jack"] != -1) && ([llength $bj($username,cards)] == 2)} { return 1 }
  if {([llength $bj($username,cards)] == 2) && ([lindex $bj($username,cards) 0] == [lindex $bj($username,cards) 1])} {return 5}
  if {($bj($username,total) < 22) && ([llength $bj($username,cards)] > 4)} { return 2 }

  if {$bj($username,total) == 21} { return 3 }
  if {$bj($username,total) > 21} { return 4 }
  if {$bj($username,total) < 22} { return 0 }

}

proc casino:blackjack:randomcard {username} {global cards bj
  set randomcard [lindex $bj($username,deck) [rand [llength $bj($username,deck)]]]
  set bj($username,deck) [ldelete $bj($username,deck) $randomcard]

  set suit [lindex [split $randomcard "."] 0]
  set card [lindex [split $randomcard "."] 1]
  if {$suit == "d"} {set suit "diamonds"}
  if {$suit == "h"} {set suit "hearts"}
  if {$suit == "s"} {set suit "spades"}
  if {$suit == "c"} {set suit "clubs"}

  if {![info exists bj($username,cards)]} { set bj($username,cards) $card } else { set bj($username,cards) "$bj($username,cards) $card" }
  return "$card of $suit"
}